unit CreateLinkToExecForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, mainform, shlobj, shellapi, activex, global, finderpopup;

type
  TFrmCreateLinkToExec = class(TForm)
    GroupBox1: TGroupBox;
    RdoStandardName: TRadioButton;
    RdoEnterName: TRadioButton;
    EdtName: TEdit;
    GroupBox2: TGroupBox;
    EdtLeft: TEdit;
    EdtRight: TEdit;
    SpdBrowseLeft: TSpeedButton;
    SpdBrowseRight: TSpeedButton;
    ChkLeft: TCheckBox;
    ChkRight: TCheckBox;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    EdtDest: TEdit;
    SpdBrowseDest: TSpeedButton;
    BtnOK: TButton;
    BtnCancel: TButton;
    ChkNewWindow: TCheckBox;
    LblStandardName: TLabel;
    btnHelp: TButton;
    procedure BtnCancelClick(Sender: TObject);
    procedure ChkLeftClick(Sender: TObject);
    procedure ChkRightClick(Sender: TObject);
    procedure RdoStandardNameClick(Sender: TObject);
    procedure SpdBrowseLeftClick(Sender: TObject);
    procedure SpdBrowseRightClick(Sender: TObject);
    procedure SpdBrowseDestClick(Sender: TObject);
    procedure BtnOKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure EdtNameChange(Sender: TObject);
    procedure btnHelpClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    function getStandardName: string;
    procedure checkOK;
  end;

var
  FrmCreateLinkToExec: TFrmCreateLinkToExec;

implementation

{$R *.dfm}

procedure TFrmCreateLinkToExec.BtnCancelClick(Sender: TObject);
begin
     close;
end;

procedure TFrmCreateLinkToExec.ChkLeftClick(Sender: TObject);
begin
     if ChkLeft.Checked then begin
        EdtLeft.Enabled := TRUE;
        SpdBrowseLeft.Enabled := TRUE;
     end else begin
        EdtLeft.Enabled := FALSE;
        SpdBrowseLeft.Enabled := FALSE;
     end;
     LblStandardName.Caption := getStandardName;
     checkOK;
end;

procedure TFrmCreateLinkToExec.ChkRightClick(Sender: TObject);
begin
     if ChkRight.Checked then begin
        EdtRight.Enabled := TRUE;
        SpdBrowseRight.Enabled := TRUE;
     end else begin
        EdtRight.Enabled := FALSE;
        SpdBrowseRight.Enabled := FALSE;
     end;
     LblStandardName.Caption := getStandardName;
     checkOK;
end;

procedure TFrmCreateLinkToExec.RdoStandardNameClick(Sender: TObject);
begin
     if RdoStandardName.Checked then
        EdtName.Enabled := FALSE
     else if RdoEnterName.Checked then begin
        If EdtName.Text = '' then edtName.Text := getStandardName;
        EdtName.Enabled := TRUE;
        EdtName.SelectAll;
        EdtName.SetFocus;
     end;
     checkOK;
end;


function showFinder(sender: TSpeedButton; stdPath: string): string;
var
   pt: TPoint;
   scr: TPoint;
begin
     pt := point(sender.width, sender.height);
     scr := sender.ClientToScreen(pt);
     result := popupFinder(scr.x, scr.y, FINDER_ALL, FrmCreateLinkToExec.Handle, true, stdPath);
     if result = '' then result := stdPath;
end;

procedure TFrmCreateLinkToExec.SpdBrowseLeftClick(Sender: TObject);
begin
     EdtLeft.Text := showFinder(SpdBrowseLeft, EdtLeft.Text);
     EdtLeft.SelectAll;
end;

procedure TFrmCreateLinkToExec.SpdBrowseRightClick(Sender: TObject);
begin
     EdtRight.Text := showFinder(SpdBrowseRight, EdtRight.Text);
     EdtRight.SelectAll;
end;

procedure TFrmCreateLinkToExec.SpdBrowseDestClick(Sender: TObject);
begin
     EdtDest.Text := showFinder(SpdBrowseDest, EdtDest.Text);
     EdtDest.SelectAll;
end;

Function CreateLink(LinkName, Path, Description, arguments: String): Boolean;
Var
   psl: IShellLink;
   ppf: IPersistFile;
   hres: HRESULT;
   wsz: Array[0..MAX_PATH] Of Word;
Begin
{     hres:=CoInitialize(Nil);
     If Succeeded(hres) Then Begin}
        hres:=CoCreateInstance(CLSID_ShellLink, Nil, CLSCTX_INPROC_SERVER, IID_IShellLinkA, psl);
        If Succeeded(hres) Then Begin
           psl._AddRef;
           psl.SetPath(PChar(Path));
           psl.SetDescription(PChar(Description));
           psl.SetArguments(pchar(arguments));
//           psl.SetIconLocation(pchar(progPath+'grafik\icons\exec.ico'), 0);
           hres:=psl.QueryInterface(IID_IPersistFile, ppf);
           If Succeeded(hres) Then Begin
               ppf._AddRef;
               MultiByteToWideChar(CP_ACP, 0, PChar(LinkName), -1,
                   PWideChar(@wsz), MAX_PATH);
               hres:=ppf.Save(PWideChar(@wsz), LongBool(True));
               ppf._Release;
           End;
           psl._Release;
        End;
{        CoUninitialize;
     End;}
     Result:=Succeeded(hres);
End;

Function RemoveEndingBackslash(Const s: String): String;
Begin
     result := trim(s);
     If result <> '' Then Begin
        If result[Length(result)] = '\' Then Begin
           Result:=Copy(result, 1, Length(result)-1);
        End;
     End;
End;

function TFrmCreateLinkToExec.getStandardName: string;
var
   tmp: string;
   left, right: string;
begin
     if ChkLeft.Checked then left := edtLeft.Text else left := '';
     if ChkRight.Checked then right := edtRight.Text else Right := '';

     if (left = '') and (right = '') then begin
        result := 'Verknpfung mit eXec';
     end else begin
        result := extractFilename(removeEndingBackslash(left));
        if result = '' then result := left;
        if not ((result = '') or (right = '')) then result := result + ' - ';
        tmp := extractFilename(removeEndingBackslash(right));
        if tmp = '' then tmp := right;
        result := result + tmp;
     end;
end;

procedure TFrmCreateLinkToExec.checkOK;
begin
     if (edtDest.Text <> '') then begin
        if RdoStandardName.checked or (RdoEnterName.Checked and (EdtName.Text <> '')) then begin
{           if not ChkLeft.Checked or (ChkLeft.Checked and (EdtLeft.Text <> '')) then begin
              if not ChkRight.Checked or (ChkRight.Checked and (EdtRight.Text <> '')) then begin}
                 btnOK.Enabled := TRUE;
                 exit;
{              end;
           end;}
        end;
     end;
     btnOK.Enabled := FALSE;
end;

function addBackslash(const s: string): string;
begin
     result := trim(s);
     if result <> '' then
        if result[length(result)] <> '\' then result := result + '\';
end;

procedure TFrmCreateLinkToExec.BtnOKClick(Sender: TObject);
var
   linkfile: string;
   left, right: string;
   complainLeft, complainRight: boolean;
   msg: string;
   found: boolean;
   i: integer;
   res: integer;
   arg: string;
begin
     linkfile := addBackslash(edtDest.Text);

     if RdoStandardName.Checked then
        linkfile:=linkfile+getStandardName
     else if RdoEnterName.Checked then linkfile:=linkfile+EdtName.Text;

     left := addBackslash(EdtLeft.Text);
     right := addBackslash(EdtRight.Text);

     Msg := '';
     complainLeft := (not directoryExists(left)) and chkLeft.Checked;
     complainRight := (not directoryExists(right)) and chkRight.Checked;

     if complainLeft or complainRight then begin

        if complainLeft and complainRight then Msg := 'Die Ordner "' else Msg := 'Der ordner "';
        if complainLEft then msg := msg + left + '" ';
        if complainLeft and complainRight then msg := msg + 'und "';
        if complainRight then msg := msg + right + '" ';
        if complainLeft and complainRight then msg := msg +'existieren nicht, oder befinden sich auf einem Datentrger, der nicht verfgbar ist.'
           else msg := msg + 'existiert nicht, oder befindet sich auf einem Datentrger, der nicht eingelegt ist.';
                msg := msg + #10 + #13 + #10 + #13 + 'Soll die Verknpfung trotzdem erstellt werden?';

        if messageDlg(msg, mtWarning, [mbYes, mbNo], 0) = mrNo then exit;
     end;

     if not directoryExists(addBackslash(edtDest.Text)) then begin
        messageDlg('Das Zielverzeichnis"'
                   +addBackslash(edtDest.Text)
                   +'" existiert nicht, oder befindet sich auf einem Datentrger, der nicht eingelegt ist.'
                   + #10 + #13 + #10 + #13
                   +'Bitte geben Sie ein anderes Zielverzeichnis ein.', mtError, [mbOK], 0);
        exit;
     end;

     if fileExists(linkfile+'.lnk') then begin
        res := messageDlg('Eine Datei mit dem Namen "'+linkfile+'.lnk'+'" existiert bereits. Soll sie berschrieben werden?', mtWarning, [mbYes, mbNo], 0);
        if res <> mrYes then begin
           found := FALSE;
           i := 1;
           repeat
                 inc(i);
                 if not fileExists(linkfile+' ('+inttostr(i)+').lnk') then begin
                    found := TRUE;
                 end;
                 if i >= 99 then exit; // nur so Sicherheit, soll ja nicht ewig dauern
           until found;
           linkfile := linkfile + ' ('+inttostr(i)+').lnk';
           messageDlg('Verknpfung wurde automatisch in "'+linkfile+'" umbenannt.', mtInformation, [mbOK], 0);
        end else linkfile := linkfile + '.lnk';
     end else linkfile := linkfile + '.lnk';


     arg := '';
     if (left <> '') then arg := arg + '"' + LOAD_LEFT_SIDE_STRING + left + '"';
     if (left <> '') and (right <> '') then arg := arg + ' ';
     if right <> '' then arg := arg + '"' + LOAD_RIGHT_SIDE_STRING + right + '"';
     if ChkNewWindow.Checked then begin
        if (left <> '') or (right <> '') then arg := arg + ' ';
        arg := arg + NEW_INSTANCE_STRING;
     end;

     createLink(linkfile, paramStr(0), '', arg);

     close;
end;

procedure TFrmCreateLinkToExec.FormShow(Sender: TObject);
begin
     EdtLEft.Text := data[LeftList].Directory+'\';
     EdtRight.Text := data[RightList].Directory+'\';
     LblStandardName.Caption := getStandardName;
     checkOK;
end;

procedure TFrmCreateLinkToExec.EdtNameChange(Sender: TObject);
begin
     LblStandardName.Caption := getStandardName;
     checkOK;
end;

procedure TFrmCreateLinkToExec.btnHelpClick(Sender: TObject);
begin
     Application.HelpCommand(HELP_CONTEXT, HelpContext);
end;

end.
