Unit PrevMulti;

Interface

Uses
    Windows, MainForm, SysUtils, inifiles, Classes, Forms, global, dialogs ;

Function PreviousInstanceIsRunning: Boolean;
Procedure FreeMultiInstancePreventingResources;
Procedure ActivatePreviousInstance;

Implementation

Const
     mutex_name = 'EXEC_BY_JAN_STRAETER_IS_RUNNING';

Var
   MutexHandle: THandle;
   execWindowFound: boolean;
   execWindowHandle: hWnd;

Function PreviousInstanceIsRunning;
Var
   PreventMultiInstances: Boolean;
   f: TINIFile;
Begin
     ProgPath:=ExtractFilePath(ParamStr(0));

     f:=TINIFile.Create(ProgPath+IniFilename);
     PreventMultiInstances:=f.ReadBool(EnhancedSection, 'PreventMultiInstances', False);
     f.Free;

     If PreventMultiInstances Then Begin
        MutexHandle:=CreateMutex(Nil, False, mutex_name);
        If (MutexHandle <> 0) And (GetLastError = ERROR_ALREADY_EXISTS) Then Begin
           Result:=True;
           MutexHandle:=0;
        End Else
           Result:=False;
     End Else Result:=False;
End;

Procedure FreeMultiInstancePreventingResources;
Begin
     If MutexHandle <> 0 Then
        CloseHandle(MutexHandle);
End;

function writeStringToFilemap(s: pchar): THANDLE;
var
   size: integer;
   len: integer;
   adr: pointer;
begin
     if length(s) > 0 then begin

        len := length(string(s));
        size := length(string(s)) + 5;

        result := createFileMapping($FFFFFFFF, NIL, PAGE_READWRITE, 0, size, DATA_EXCHANGE_FILE);

        if result <> 0 then begin
           adr := MapViewOfFile(result, FILE_MAP_ALL_ACCESS, 0, 0, 0);
           if adr <> NIL then begin
              asm
                 pushad

                 mov edi, adr
                 mov esi, s

                 mov ecx, len
                 mov [edi], ecx
                 add edi, 4

              @loop1:
                 mov al, [esi]
                 mov [edi], al
                 inc esi
                 inc edi
                 dec ecx
                 jne @loop1

                 mov [edi], 0

                 popad
              end;
           end;
        end;

     end else result := 0;
end;

function enumWindowsCallback(handle: THandle; param: LParam): bool; stdcall;
var
   buffer: array[0..256] of char;
   len: integer;
begin
     len := getWindowText(handle, buffer, 255);
     if len <> 0 then begin
        if pos(exec_caption, string(buffer)) <> 0 then begin
           len := getClassName(handle, buffer, 255);
           if len > 0 then begin
              if ansiUpperCase(string(buffer)) = ansiUpperCase(exec_WndClass) then begin
                 execWindowFound := TRUE;
                 execWindowHandle := handle;
                 result := FALSE;
                 exit;
              end;
           end;
        end;
     end;
     result := TRUE;
end;

Procedure ActivatePreviousInstance;
Var
   PrevhWnd: hWnd;
   tmp: thandle;
Begin
     Application.Title:='';
     execWindowFound := FALSE;
     execWindowHandle := 0;
     enumWindows(@enumWindowsCallback, 0);
     prevhwnd := execWindowHandle;
     If PrevhWnd <> 0 Then Begin
        if (loadleft <> '') and (loadright <> '') then begin
           tmp := writeStringToFilemap(pchar(loadLeft+'|'+loadright));
           PostMessage(prevhwnd, loadDirectoryMessage, tmp, 0);
        end;
        SetForegroundWindow(PrevhWnd);
        If IsIconic(PrevhWnd) Then
           ShowWindowAsync(PrevhWnd, SW_RESTORE);
     End;
     Application.Title:=eXec_Caption;
End;

Initialization
   MutexHandle:=0;
Finalization
   FreeMultiInstancePreventingResources;
End.
