unit SetAttrForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, MainForm, SearchDir;

type
  TFrmSetAttr = class(TForm)
    BvlLine: TBevel;
    Bevel1: TBevel;
    Label3: TLabel;
    Label4: TLabel;
    LblSubDirs: TLabel;
    LblFileNum: TLabel;
    ImgSetAttr: TImage;
    BtnOK: TButton;
    BtnCancel: TButton;
    GrpOptions: TGroupBox;
    ChkRecursive: TCheckBox;
    ChkUseFilter: TCheckBox;
    ChkArchive: TCheckBox;
    ChkReadOnly: TCheckBox;
    ChkHidden: TCheckBox;
    ChkSysFile: TCheckBox;
    BtnHelp: TButton;
    procedure FormActivate(Sender: TObject);
    procedure ChkRecursiveClick(Sender: TObject);
    procedure ChkUseFilterClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BtnHelpClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
    dirInfoThread: TDirInfoThread;
    Procedure WMNCHitTest(Var Msg: TMessage); Message WM_NCHITTEST;
    Procedure UpdateInfo;
  public
    { Public-Deklarationen }
    SourceList: Integer;
  end;

var
  FrmSetAttr: TFrmSetAttr;

implementation

{$R *.DFM}

Procedure dirInfoThreadCallback(FileNum, DirNum: Integer; SizeInBytes: Int64; SysFiles, HiddenFiles, ReadOnlyFiles, ArchiveFiles: Longint; LastCall: Boolean);
var
   objNum: integer;
begin
     if LastCall then begin
        DIThreadFinished := TRUE;
        DISizeInBytes := sizeInBytes;
        DIFileNum := fileNum;
        DISubDirs := dirNum;
        DIObjNum := fileNum + dirNum;
        DISysFiles := sysFiles;
        DIHiddenFiles := hiddenFiles;
        DIReadOnlyFiles := ReadOnlyFiles;
        DIArchiveFiles := ArchiveFiles;
     end;
     FrmSetAttr.LblSubDirs.Caption:=Formatted(DirNum);
     FrmSetAttr.LblFileNum.Caption:=Formatted(FileNum);
     ObjNum:=FileNum+DirNum;
     If HiddenFiles >= ObjNum Then
        FrmSetAttr.ChkHidden.State:=cbChecked
     Else If HiddenFiles = 0 Then
        FrmSetAttr.ChkHidden.State:=cbUnchecked
     Else
        FrmSetAttr.ChkHidden.State:=cbGrayed;
     If SysFiles >= ObjNum Then
        FrmSetAttr.ChkSysFile.State:=cbChecked
     Else If SysFiles = 0 Then
        FrmSetAttr.ChkSysFile.State:=cbUnchecked
     Else
        FrmSetAttr.ChkSysFile.State:=cbGrayed;
     If ReadOnlyFiles >= ObjNum Then
        FrmSetAttr.ChkReadOnly.State:=cbChecked
     Else If ReadOnlyFiles = 0 Then
        FrmSetAttr.ChkReadOnly.State:=cbUnchecked
     Else
        FrmSetAttr.ChkReadOnly.State:=cbGrayed;
     If ArchiveFiles >= ObjNum Then
        FrmSetAttr.ChkArchive.State:=cbChecked
     Else If ArchiveFiles = 0 Then
        FrmSetAttr.ChkArchive.State:=cbUnchecked
     Else
        FrmSetAttr.ChkArchive.State:=cbGrayed;
end;


procedure TFrmSetAttr.UpdateInfo;
var
   tmp: TFilterRec;
begin
     if assigned(dirInfoThread) then begin
        dirInfoThread.Terminate;
        dirInfoThread.WaitFor;
        dirInfoThread.Destroy;
        dirInfoThread := NIL;
     end;
     if ChkUseFilter.Checked then tmp := data[currentList].Filter else tmp := FilterAllFiles;
     dirInfoThread := TDirInfoThread.Create(currentList, ChkRecursive.Checked, FALSE, tmp, 250, dirInfoThreadCallback);
end;

procedure TFrmSetAttr.FormActivate(Sender: TObject);
begin
     BtnOK.SetFocus;
     ChkrecursiveClick(Nil);
end;

Procedure TFrmSetAttr.ChkRecursiveClick(Sender: TObject);
Begin
     ChkUseFilter.Enabled:=ChkRecursive.Checked;
     UpdateInfo;
End;

procedure TFrmSetAttr.ChkUseFilterClick(Sender: TObject);
begin
     ChkRecursiveClick(Nil);
end;

procedure TFrmSetAttr.FormCreate(Sender: TObject);
begin
     HelpContext:=IDH_FileSetAttr;
end;

procedure TFrmSetAttr.BtnHelpClick(Sender: TObject);
begin
     Application.HelpCommand(HELP_CONTEXT, HelpContext);
End;

Procedure TFrmSetAttr.WMNCHitTest(Var Msg : TMessage);
Var
   i: Integer;
   r: TRect;
   ctrl: TControl;

Function LeftMouseButtonPressed: Boolean;
Begin
     If GetSystemMetrics(SM_SWAPBUTTON) = 0 Then
        Result:=(GetAsyncKeyState(VK_LBUTTON) < 0)
     Else
        Result:=(GetAsyncKeyState(VK_RBUTTON) < 0);
End;

Begin
     If Options.WindowClientDraggable And LeftMouseButtonPressed Then Begin
        If (Msg.LParamLo >= Self.ClientToScreen(Point(0, 0)).x) And
           (Msg.LParamHi >= Self.ClientToScreen(Point(0, 0)).y) And
           (Msg.LParamLo <= Self.ClientToScreen(Point(Self.ClientWidth, Self.ClientHeight)).x) And
           (Msg.LParamHi <= Self.ClientToScreen(Point(Self.ClientWidth, Self.ClientHeight)).y)
        Then Begin
             For i:=0 To Self.ComponentCount-1 Do Begin
                 Try
                    If Self.Components[i] Is TControl Then Begin
                       ctrl:=TControl(Self.Components[i]);
                       r:=ctrl.BoundsRect;
                       If (Msg.LParamLo >= Self.ClientToScreen(Point(r.Left, r.Top)).x) And
                          (Msg.LParamHi >= Self.ClientToScreen(Point(r.Left, r.Top)).y) And
                          (Msg.LParamLo <= Self.ClientToScreen(Point(r.Right, r.Bottom)).x) And
                          (Msg.LParamHi <= Self.ClientToScreen(Point(r.Right, r.Bottom)).y) And ctrl.Visible
                       Then Begin
                          Msg.Result:=DefWindowProc(Handle, Msg.Msg, Msg.WParam, Msg.LParam);
                          Exit;
                       End;
                    End;
                 Except
                    Msg.Result:=DefWindowProc(Handle, Msg.Msg, Msg.WParam, Msg.LParam);
                    Exit;
                 End;
             End;
             Msg.Result:=HTCAPTION
        End Else
           Msg.Result:=DefWindowProc(Handle, Msg.Msg, Msg.WParam, Msg.LParam);
     End Else
        Msg.Result:=DefWindowProc(Handle, Msg.Msg, Msg.WParam, Msg.LParam);
End;

procedure TFrmSetAttr.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     if assigned(dirInfoThread) then begin
        dirInfoThread.Terminate;
        dirInfoThread.WaitFor;
        dirInfoThread.Destroy;
        dirInfoThread := NIL;
     end;
end;

end.
