unit createlinkform;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ShlObj, ExtCtrls, Buttons, finderpopup;

type
  TFrmCreateLink = class(TForm)
    BtnOK: TButton;
    BtnCancel: TButton;
    EdtDest: TEdit;
    Bevel1: TBevel;
    Label1: TLabel;
    Image1: TImage;
    BtnHelp: TButton;
    Label3: TLabel;
    Label4: TLabel;
    LblSubDirs: TLabel;
    LblFileNum: TLabel;
    Bevel2: TBevel;
    SpdBrowse: TSpeedButton;
    procedure FormActivate(Sender: TObject);
    procedure EdtDestChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BtnHelpClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpdBrowseClick(Sender: TObject);
  private
    { Private-Deklarationen }
    Procedure WMNCHitTest(Var Msg: TMessage); Message WM_NCHITTEST;
  public
    { Public-Deklarationen }
    SourceList: Integer;
  end;

var
  FrmCreateLink: TFrmCreateLink;

implementation

{$R *.DFM}

Uses
    MainForm;

procedure TFrmCreateLink.FormActivate(Sender: TObject);
begin
     EdtDestChange(Sender);
     EdtDest.SelStart:=0;
     EdtDest.SelLength:=Length(EdtDest.Text);
     EdtDest.SetFocus;
end;

procedure TFrmCreateLink.EdtDestChange(Sender: TObject);
begin
     If EdtDest.Text <> '' Then BtnOK.Enabled:=True Else BtnOK.Enabled:=False;
end;

procedure TFrmCreateLink.FormShow(Sender: TObject);
Var
   FileNum, DirNum: Longint;
   SizeInBytes: Int64;
begin
     DirInfo(False, False, False, SourceList, FileNum, DirNum, SizeInBytes);
     LblSubDirs.Caption:=Formatted(DirNum);
     LblFileNum.Caption:=Formatted(FileNum);
end;

procedure TFrmCreateLink.BtnHelpClick(Sender: TObject);
begin
     Application.HelpCommand(HELP_CONTEXT, HelpContext);
End;

procedure TFrmCreateLink.FormCreate(Sender: TObject);
begin
     HelpContext:=IDH_FileCreateLink;
end;

Procedure TFrmCreateLink.WMNCHitTest(Var Msg : TMessage);
Var
   i: Integer;
   r: TRect;
   ctrl: TControl;

Function LeftMouseButtonPressed: Boolean;
Begin
     If GetSystemMetrics(SM_SWAPBUTTON) = 0 Then
        Result:=(GetAsyncKeyState(VK_LBUTTON) < 0)
     Else
        Result:=(GetAsyncKeyState(VK_RBUTTON) < 0);
End;

Begin
     If Options.WindowClientDraggable And LeftMouseButtonPressed Then Begin
        If (Msg.LParamLo >= Self.ClientToScreen(Point(0, 0)).x) And
           (Msg.LParamHi >= Self.ClientToScreen(Point(0, 0)).y) And
           (Msg.LParamLo <= Self.ClientToScreen(Point(Self.ClientWidth, Self.ClientHeight)).x) And
           (Msg.LParamHi <= Self.ClientToScreen(Point(Self.ClientWidth, Self.ClientHeight)).y)
        Then Begin
             For i:=0 To Self.ComponentCount-1 Do Begin
                 Try
                    If Self.Components[i] Is TControl Then Begin
                       ctrl:=TControl(Self.Components[i]);
                       r:=ctrl.BoundsRect;
                       If (Msg.LParamLo >= Self.ClientToScreen(Point(r.Left, r.Top)).x) And
                          (Msg.LParamHi >= Self.ClientToScreen(Point(r.Left, r.Top)).y) And
                          (Msg.LParamLo <= Self.ClientToScreen(Point(r.Right, r.Bottom)).x) And
                          (Msg.LParamHi <= Self.ClientToScreen(Point(r.Right, r.Bottom)).y) And ctrl.Visible
                       Then Begin
                          Msg.Result:=DefWindowProc(Handle, Msg.Msg, Msg.WParam, Msg.LParam);
                          Exit;
                       End;
                    End;
                 Except
                    Msg.Result:=DefWindowProc(Handle, Msg.Msg, Msg.WParam, Msg.LParam);
                    Exit;
                 End;
             End;
             Msg.Result:=HTCAPTION
        End Else
           Msg.Result:=DefWindowProc(Handle, Msg.Msg, Msg.WParam, Msg.LParam);
     End Else
        Msg.Result:=DefWindowProc(Handle, Msg.Msg, Msg.WParam, Msg.LParam);
End;

function showFinder(sender: TSpeedButton; stdPath: string): string;
var
   pt: TPoint;
   scr: TPoint;
begin
     pt := point(sender.width, sender.height);
     scr := sender.ClientToScreen(pt);
     result := popupFinder(scr.x, scr.y, FINDER_ALL, FrmCreateLink.Handle, true, stdPath);
     if result = '' then result := stdPath;
end;

procedure TFrmCreateLink.SpdBrowseClick(Sender: TObject);
begin
     EdtDest.Text := showFinder(SpdBrowse, EdtDest.Text);
     EdtDest.SelectAll;
end;

end.
