program eXec;

uses
  SysUtils,
  Forms,
  FormDrive in 'FormDrive.pas' {FrmChangeDriveDir},
  SelForm in 'SelForm.pas' {FrmSelectionMask},
  aboutform in 'aboutform.pas' {FrmAbout},
  formprog1 in 'formprog1.pas' {FrmCopyMoveStatus},
  formprog2 in 'formprog2.pas' {FrmDeleteStatus},
  newdirform in 'newdirform.pas' {FrmNewDir},
  attrstatusform in 'attrstatusform.pas' {FrmSetAttrStatus},
  settingsform in 'settingsform.pas' {FrmSettings},
  createlinkform in 'createlinkform.pas' {FrmCreateLink},
  findfileform in 'findfileform.pas' {FrmFindFile},
  EditPathListForm in 'EditPathListForm.pas' {FrmEditPathList},
  GoToForm in 'GoToForm.pas' {FrmGoTo},
  quickviewform in 'quickviewform.pas' {FrmQuickView},
  FilterForm in 'FilterForm.pas' {FrmFilter},
  SaveFilterForm in 'SaveFilterForm.pas' {FrmSaveFilter},
  CopyMoveForm in 'CopyMoveForm.pas' {FrmCopyMove},
  DeleteForm in 'DeleteForm.pas' {FrmDelete},
  SetAttrForm in 'SetAttrForm.pas' {FrmSetAttr},
  TextEditForm in 'TextEditForm.pas' {FrmTextEdit},
  replaceform in 'replaceform.pas' {FrmReplace},
  findform in 'findform.pas' {FrmFind},
  EditPathForm in 'EditPathForm.pas' {FrmEditPath},
  FormatDrive in 'FormatDrive.pas',
  FormatForm in 'FormatForm.pas' {FrmFormat},
  MediaInformationForm in 'MediaInformationForm.pas' {FrmMediaInformation},
  RenameMediaForm in 'RenameMediaForm.pas' {FrmRenameMedia},
  MainForm in 'mainform.pas' {FrmMain},
  ProgDragDropForm in 'ProgDragDropForm.pas' {FrmProgDragDrop},
  DivideFileForm in 'DivideFileForm.pas' {FrmDivideFile},
  cooldir in 'cooldir.pas',
  CompareDirectoriesForm in 'CompareDirectoriesForm.pas' {FrmCompareDirectories},
  ExecuteWithParamForm in 'ExecuteWithParamForm.pas' {FrmExecuteWithParam},
  DivideFileProgressForm in 'DivideFileProgressForm.pas' {FrmDivideFileProgress},
  ConcatFileForm in 'ConcatFileForm.pas' {FrmConcatFile},
  ConcatFileProgressForm in 'ConcatFileProgressForm.pas' {FrmConcatFileProgress},
  PrevMulti in 'PrevMulti.pas',
  global in 'global.pas',
  CreateLinkToExecForm in 'CreateLinkToExecForm.pas' {FrmCreateLinkToExec},
  finderpopup in 'finderpopup.pas';

{$R *.RES}

Function RemoveEndingBackslash(Const s: String): String;
Begin
     result := trim(s);
     If result <> '' Then Begin
        If result[Length(result)] = '\' Then Begin
           Result:=Copy(result, 1, Length(result)-1);
        End;
     End;
End;

var
   i: integer;
   tmp: string;
   newInstance: boolean;

begin
  newInstance := FALSE;
  loadLeft := '';
  loadRight := '';

  if paramCount > 0 then begin
     for i := 1 to paramCount do begin
         tmp := paramStr(i);
         if ansiLowerCase(tmp) = NEW_INSTANCE_STRING then begin
            newInstance := TRUE;
         end else begin
            if pos(LOAD_LEFT_SIDE_STRING, ansiLowerCase(trim(tmp))) = 1 then begin
               loadLeft := removeEndingBackslash(copy(tmp, length(LOAD_LEFT_SIDE_STRING)+1, length(tmp) - length(LOAD_LEFT_SIDE_STRING)));
            end else if pos(LOAD_RIGHT_SIDE_STRING, ansiLowerCase(trim(tmp))) = 1 then begin
               loadRight := removeEndingBackslash(copy(tmp, length(LOAD_RIGHT_SIDE_STRING)+1, length(tmp) - length(LOAD_RIGHT_SIDE_STRING)));
            end else begin
               loadLeft := tmp;
            end;
         end;
     end;
  end;

  previousInstanceFound := PreviousInstanceIsRunning;

  if not NewInstance then begin
     If previousInstanceFound Then Begin
        ActivatePreviousInstance;
        Halt;
     End;
  end;

  Application.Initialize;
  Application.Title := 'eXec 3.0';
  Application.CreateForm(TFrmMain, FrmMain);
  Application.CreateForm(TFrmAbout, FrmAbout);
  Application.CreateForm(TFrmSelectionMask, FrmSelectionMask);
  Application.CreateForm(TFrmChangeDriveDir, FrmChangeDriveDir);
  Application.CreateForm(TFrmCopyMoveStatus, FrmCopyMoveStatus);
  Application.CreateForm(TFrmDeleteStatus, FrmDeleteStatus);
  Application.CreateForm(TFrmNewDir, FrmNewDir);
  Application.CreateForm(TFrmSetAttrStatus, FrmSetAttrStatus);
  Application.CreateForm(TFrmSettings, FrmSettings);
  Application.CreateForm(TFrmCreateLink, FrmCreateLink);
  Application.CreateForm(TFrmFindFile, FrmFindFile);
  Application.CreateForm(TFrmEditPathList, FrmEditPathList);
  Application.CreateForm(TFrmGoTo, FrmGoTo);
  Application.CreateForm(TFrmQuickView, FrmQuickView);
  Application.CreateForm(TFrmFilter, FrmFilter);
  Application.CreateForm(TFrmSaveFilter, FrmSaveFilter);
  Application.CreateForm(TFrmCopyMove, FrmCopyMove);
  Application.CreateForm(TFrmDelete, FrmDelete);
  Application.CreateForm(TFrmSetAttr, FrmSetAttr);
  Application.CreateForm(TFrmReplace, FrmReplace);
  Application.CreateForm(TFrmFind, FrmFind);
  Application.CreateForm(TFrmEditPath, FrmEditPath);
  Application.CreateForm(TFrmFormat, FrmFormat);
  Application.CreateForm(TFrmMediaInformation, FrmMediaInformation);
  Application.CreateForm(TFrmRenameMedia, FrmRenameMedia);
  Application.CreateForm(TFrmProgDragDrop, FrmProgDragDrop);
  Application.CreateForm(TFrmDivideFile, FrmDivideFile);
  Application.CreateForm(TFrmCompareDirectories, FrmCompareDirectories);
  Application.CreateForm(TFrmExecuteWithParam, FrmExecuteWithParam);
  Application.CreateForm(TFrmDivideFileProgress, FrmDivideFileProgress);
  Application.CreateForm(TFrmConcatFile, FrmConcatFile);
  Application.CreateForm(TFrmConcatFileProgress, FrmConcatFileProgress);
  Application.CreateForm(TFrmCreateLinkToExec, FrmCreateLinkToExec);
  Application.Run;
end.
